#include "utils.PRO2"
#include "Estudiant.hpp"
#include "LlistaIOint.hpp"
#include "LlistaIOEstudiant.hpp"

#include <list>



void llegir_llista_int(list<int> &l, int marca)
{
  int n;
  cin >> n;
  list<int>::iterator it= l.end();
  while (n != marca){
    l.insert(it,n);
    cin >> n;
  }
}

void _llista_int(const list<int> &l)
{
  cout << "[Primer] ";
  for (list<int>::const_iterator it= l.begin();it!=l.end();++it)
    cout << *it << " ";
  cout << "[Ultim]"<<endl;
}

int suma_llista_int(const list<int>& L)
/* Pre: cert */
{
  int s=0;
  for(list<int>::const_iterator it= L.begin();it != L.end(); ++it)
    s+=*it;
  return s;
}
/* Post: El resultat és la suma dels elements de L */


bool pert_llista_int(const list<int>& l, int x)
/* Pre: cert */
{
  bool b = false;
  list<int>::const_iterator it= l.begin();
  while ( it != l.end() and not b){
    if (*it == x) b= true;
    else ++it;
  }
  return b;
}
/* Post: El resultat indica si x hi és o no a l */


list<int>::iterator pert_llista_int1(list<int>& l, int x)
/* Pre: cert */
{
  bool b=false;
  list<int>::iterator it= l.begin();
  while ( it != l.end() and not b){
    if (*it == x) b=true;
    else ++it;
  }
  return it;
}
/* Post: El resultat és un iterador a la primera aparció d'x si
   x hi és o a l.end() si no hi és */


list<int>::iterator pert_llista_int2(list<int>& l, int x) {
  for (list<int>::iterator it= l.begin(); it != l.end(); ++it)
    if (*it == x) return it;
  return l.end();
}
/* Post: El resultat indica és un iterador a la primera aparció d'x si
   x hi és o a l.end() si no hi és */


void llegir_llista_Estudiant(list<Estudiant> &l, int marca) {
  Estudiant n;
  n.llegir_estudiant();
  list<Estudiant>::iterator it= l.begin();
  while (n.consultar_DNI() != marca){
    l.insert(it,n);
    n.llegir_estudiant();
  }
}


bool pert_llista_Estudiant(const list<Estudiant>& l, int x)
/* Pre: cert */
{
  bool b =false;
  list<Estudiant>::const_iterator it = l.begin();
  b=false;
  while (it != l.end() and not b){
    if ((*it).consultar_DNI() == x) b= true;
    else ++it;
  }
  return b;
}
/* Post: El resultat ens indica si hi ha algun estudiant amb dni x a l o no */


void suma_llista_k(list<int>& l, int k)
/* Pre: l=L */
{
  list<int>::iterator it= l.begin();
  while (it != l.end()){
    *it+=k;
    ++it;      
  }
}
/* Post: El valor de cada element d'l és el valor corresponent a L més k */ 


list<int> suma_llista_k_fun(const list<int>& l, int k)
/* Pre: cert */
{
  list<int>::const_iterator it=l.begin();
  list<int> l2;
  list<int>::iterator it2=l2.begin();
  
  while (it != l.end()) {
    l2.insert(it2,*it+k);
    ++it;
  }
  return l2;
}
/* Post: Cada element del resultat es la suma de k i l'element d'l1 a la seva 
   mateixa posició */ 


int main(){

  list<int> l;
  cout << "Entra llista enters (acabada per 0): " << endl;
  llegir_llista_int(l,0);
  cout << "Suma: " <<  suma_llista_int(l) << endl;
  int x;
  cout << "Número a cercar: "; 
  cin >> x;
  if (pert_llista_int(l,x)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  if (pert_llista_int1(l,x)!=l.end()) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  cout << "Número a afegir (Func): "; 
  cin >> x;
  list<int> l1 = suma_llista_k_fun(l,x);
  escriure_llista_int(l1);
  cout << "Número a afegir (Acc): "; 
  cin >> x;
  suma_llista_k(l,x);
  escriure_llista_int(l);
  cout << "Entra llista Estudiants (acabada per DNI 0): " << endl;
  list<Estudiant> lest;
  llegir_llista_Estudiant(lest,0);
  cout << "Entra dni a cercar: " << endl;
  cin >> x;
  if (pert_llista_Estudiant(lest,x)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
}
