#include "utils.PRO2"
#include "LlistaIOint.hpp"
#include <list>


/* Pre: l1 i l2 estan ordenades; */
list<int> merge1(const list<int>& l1, const list<int>& l2)
{
  list<int>::const_iterator it1=l1.begin();
  list<int>::const_iterator it2=l2.begin();
  list<int> l3;
  list<int>::iterator it3=l3.end();  
  while (it1 != l1.end() and it2 != l2.end()) {
    if (*it1 <= *it2) {
      l3.insert(l3.end(),*it1); 
      ++it1;
    } 
    else{
      l3.insert(it3,*it2); 
      ++it2;
    } 
  }
  while (it1 != l1.end()) {
    l3.insert(it3,*it1); 
    ++it1;
  } 
  while (it2 != l2.end()) {
    l3.insert(it3,*it2); 
    ++it2;
  }
  return l3;
}
/* Post: retorna la mescla d'l1 i l2 */ 



void merge2(list<int>& l1, list<int>& l2)
/* Pre: l1 i l2 estan ordenades; l1=L1; l2=L2 */
{
  list<int>::iterator it1=l1.begin();
  list<int>::iterator it2=l2.begin();
  while (it1 != l1.end() and it2 != l2.end()) {
    if (*it1 <= *it2) {
      ++it1;
    } 
    else{
      l1.insert(it1,*it2); 
      it2=l2.erase(it2);
    } 
  }
  while (it2 != l2.end()) {
    l1.insert(it1,*it2);
    it2=l2.erase(it2);
  }
}
/* Post: l1 conté la mescla d'L1 i L2; l2 és buida */ 



void msort(list<int>& l){
  int m=l.size();
  if (m>1) {
    m=m/2;
    list<int>::iterator it=l.begin();
    list<int> l1;
    list<int>::iterator it1=l1.end();
    while (m!=0){
      l1.insert(it1,*it);
      it=l.erase(it);
      --m;
    }
    msort(l);
    msort(l1);
    merge2(l,l1);
  }
}
  

int main(){

  list<int> l1;
  cout << "Entra llista ordenada d'enters (acabada per 0): " << endl;
  llegir_llista_int(l1,0);
  list<int> l2;
  cout << "Entra llista ordenada d'enters (acabada per 0): " << endl;
  llegir_llista_int(l2,0);
  list<int> l3=merge1(l1,l2);
  escriure_llista_int(l3);
  merge2(l1,l2);
  escriure_llista_int(l1);
  escriure_llista_int(l2);
  cout << "Entra llista d'enters (acabada per 0): " << endl;
  llegir_llista_int(l2,0);
  cout << "abans del sort" << endl;
  escriure_llista_int(l2);
  msort(l2);
  escriure_llista_int(l2);
  list<int>::iterator it=l2.begin();
  l2.insert(it,3);
  escriure_llista_int(l2);
  l1.splice(l1.begin(),l2);
  escriure_llista_int(l1);  
}


